ad_library {

	Library for Mash Up : Tagclouds

    @author Hamilton Chua (ham@solutiongrove.com)
    @creation-date 2006-03-20
}

namespace eval mashup::tagcloud { }

# ******* TAGCLOUDS ***********

ad_proc -public mashup::tagcloud::new {
	-user_id
	-cloud_name
	{-num_of_tags "30"}
} {
	Insert tagcloud name into tagcloud table
} {
	set id [db_nextval "tagcloud_id"]
	db_dml "insertcloud" "insert into tagcloud (id,user_id,num_of_tags,cloud_name) values (:id,:user_id,:num_of_tags,:cloud_name)"
	return $id
}

ad_proc -public mashup::tagcloud::del {
	-user_id
	-id
} {
	Delete a specific tagcloud
} {
	db_dml "deletecloud" "delete from tagcloud where id=:id and user_id=:user_id"
}

ad_proc -public mashup::tagcloud::delall {
	-user_id
} {
	Deletes all the tagclouds of a give user_id
} {
	db_dml "deletecloud" "delete from mashup_feeds where user_id=:user_id"
}

ad_proc -public mashup::tagcloud::gencss  {
	-cloud_name
	{-user_id ""}
	{-num_of_tags "30"}
} {
	Generate the css code to include in the html head
} {
	if { [db_0or1row "getcloud" "select * from tagcloud where cloud_name=:cloud_name and user_id=:user_id"] } {
		return "<link href=\"http://www.tagcloud.com/cloud/css/${cloud_name}/default/${num_of_tags}\" rel=\"stylesheet\" type=\"text/css\">"
	} else {
		ns_log Notice "No entry for $cloud_name by user $user_id found in tagcloud table"
	}
}

ad_proc -public mashup::tagcloud::exists {
	-cloud_name
	{-num_of_tags "30"}
} {
	Check if the cloud exists.
	Returns 1 if YES,
	Returns 0 if NO
} {
	set url "http://www.tagcloud.com/cloud/xml/${cloud_name}/default/${num_of_tags}"
	set doc [util_httpget $url]
	if { $doc == "document.writeln('This cloud does not exist');" } {
		return 0
	} else {
		return 1
	}
}

ad_proc -public mashup::tagcloud::gencloudxml {
	-cloud_name
	{-user_id ""}
	{-num_of_tags "30"}
} {
	Generate the javscript code to be placed in the html body
} {
	if { [db_0or1row "getcloud" "select * from tagcloud where cloud_name=:cloud_name and user_id=:user_id"] } {
		set url "http://www.tagcloud.com/cloud/xml/${cloud_name}/default/${num_of_tags}"
		set doc [util_httpget $url]
		set xml [xml_parse -persist $doc]
    		set root [xml_doc_get_first_node $xml]
		set tags [xml_node_get_first_child_by_name $root "Tags"]
		set tagcloud ""
		foreach tag [xml_node_get_children_by_name $tags "Tag"] {
			set name [xml_node_get_content [xml_node_get_first_child_by_name $tag "Name"]]
			set scale [xml_node_get_content [xml_node_get_first_child_by_name $tag "Scale"]]
			set link [xml_node_get_content [xml_node_get_first_child_by_name $tag "Link"]]
			append tagcloud "<span class=\"level${scale}\"><a href=\"${link}\" target=\"blank\">${name}</a></span> "
		}
		return ${tagcloud}
	} else {
		ns_log Notice "No entry for $cloud_name by user $user_id found in tagcloud table"
	}
	return ""
}

ad_proc -public mashup::tagcloud::gencloud  {
	-cloud_name
	{-user_id ""}
	{-num_of_tags "30"}
} {
	Generate the javscript code to be placed in the html body
} {
	if { [db_0or1row "getcloud" "select * from tagcloud where cloud_name=:cloud_name and user_id=:user_id"] } {
		return "<script language=\"JavaScript\" type=\"text/javascript\" src=\"http://www.tagcloud.com/cloud/js/${cloud_name}/default/${num_of_tags}\"></script>"		
		# set url "http://www.tagcloud.com/cloud/js/${cloud_name}/default/${num_of_tags}"
		# return [util_httpget $url]
	} else {
		ns_log Notice "No entry for $cloud_name by user $user_id found in tagcloud table"
	}
}

ad_proc -public mashup::tagcloud::directlink  {
	-cloud_name
	{-user_id ""}
	{-num_of_tags "30"}
} {
	Generate the direct link to the tagcloud public page
} {
	if { [db_0or1row "getcloud" "select * from tagcloud where cloud_name=:cloud_name and user_id=:user_id"] } {
		return "<a href=\"http://www.tagcloud.com/cloud/html/${cloud_name}/default/${num_of_tags}\">${cloud_name}</a>"
	} else {
		ns_log Notice "No entry for $cloud_name by user $user_id found in tagcloud table"
	}
}
